import { IRegExactExecArray } from "./regexact";
declare class PatternState {
    pattern: string;
    cursor: number;
    constructor(pattern: string, cursor?: number);
    get(): string;
    isNotEqual(char: string): boolean;
}
export declare class GroupsMapper {
    index: number;
    xIndex: number;
    indexToXindex: Map<number, number>;
    constructor(index?: number, xIndex?: number);
}
declare class FixResultState {
    index: number;
    cursor: number;
    constructor(index: number, cursor: number);
}
export declare class SyntaxTree {
    type: string;
    protected children: SyntaxTree[];
    protected containsReference: boolean;
    protected containsCapturingGroup: boolean;
    protected virtualCapturingGroupsCount: number;
    constructor();
    toPattern(_nodesMapper: GroupsMapper): string;
    fixResult(_xExecValue: IRegExactExecArray, _optimization: boolean, _fixResultState: FixResultState): void;
    protected manageChild(child: SyntaxTree): void;
}
declare class QuantifiedGroup extends SyntaxTree {
    private quantifier;
    private groupType;
    constructor(patternState: PatternState, nodesMapper: GroupsMapper);
    toPattern(nodesMapper: GroupsMapper): string;
    fixResult(xExecValue: IRegExactExecArray, optimization: boolean, fixResultState: FixResultState): void;
}
export declare class Root extends QuantifiedGroup {
    private nodesMapper;
    constructor(pattern: string);
    toPattern(): string;
    fixResult(xExecValue: IRegExactExecArray, optimization: boolean): void;
}
export {};
